Friend Class CCompareTagNodekey
    ' Calls CaseInsensitiveComparer.Compare with the ToString() parameters.
    Implements IComparer

    Friend Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
       Implements IComparer.Compare
        Dim xItem, yItem As CTreeNodeTag
        xItem = x
        yItem = y
        If (xItem.SortKey.Equals(yItem.SortKey)) Then
            Return New CaseInsensitiveComparer().Compare(xItem.NodeKey, yItem.NodeKey)
        End If
        Return New CaseInsensitiveComparer().Compare(xItem.SortKey, yItem.SortKey)
    End Function 'IComparer.Compare
End Class
Friend Class CCompareTagMedcinId
    ' Calls CaseInsensitiveComparer.Compare with the ToString() parameters.
    Implements IComparer

    Friend Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
       Implements IComparer.Compare
        Dim xItem, yItem As CTreeNodeTag
        xItem = x
        yItem = y
        If (xItem.Medcinid.Equals(yItem.Medcinid)) Then
            Return New CaseInsensitiveComparer().Compare(xItem.Etime, yItem.Etime)
        End If
        Return IIf(xItem.Medcinid < yItem.Medcinid, -1, 1)
    End Function 'IComparer.Compare
End Class

Friend Class CTreeNodeTag
    Friend Enum RnTypes As Short
        ''' <summary>Not a nurse finding or value not set.</summary>
        None = 0
        ''' <summary>A nurse RNDx finding.</summary>
        Dx = 1
        ''' <summary>A nurse RNRx finding.</summary>
        Rx = 2
        ''' <summary>A nurse RNOx finding.</summary>
        Ox = 3
    End Enum
    ' Object to use for adding additional data to a PlanOfCare treenode
    Dim myMedcinid As Integer
    Dim myCaption As String
    Dim myPrefix As String
    Dim myCCC As String = String.Empty
    Dim myNodeKey As String
    Dim myEtime As String
    Dim myStatus As String = String.Empty
    Dim mySortKey As String = ""
    Dim myValue As String = String.Empty
    Dim mySig As String = String.Empty
    Dim myUnit As String = String.Empty
    Dim myRNType As RnTypes
    Dim myRNRxList As ArrayList = Nothing
    Sub New()
        myPrefix = " "
    End Sub
    Friend Sub New(ByVal Prefix As String)
        myPrefix = Prefix
    End Sub
    Friend Sub New(ByVal Prefix As String, ByVal Medcinid As Integer)
        myPrefix = Prefix
        myMedcinid = Medcinid
    End Sub
    Friend Sub New(ByVal Prefix As String, ByVal Medcinid As Integer, ByVal caption As String)
        myPrefix = Prefix
        myMedcinid = Medcinid
        myCaption = caption
    End Sub
    Friend Function Clone() As CTreeNodeTag
        Dim oNewTag As New CTreeNodeTag
        With oNewTag
            .Caption = myCaption
            .CCC = myCCC
            .Etime = myEtime
            .Medcinid = myMedcinid
            .NodeKey = myNodeKey
            .Prefix = myPrefix
            .RNType = myRNType
            .SIG = mySig
            .Status = myStatus
            .Unit = myUnit
            .Value = myValue
        End With
        Return oNewTag
    End Function

    Property Caption() As String
        Get
            Return myCaption
        End Get
        Set(ByVal value As String)
            myCaption = value
        End Set
    End Property
    Property CCC() As String
        Get
            Return myCCC
        End Get
        Set(ByVal value As String)
            myCCC = value
        End Set
    End Property
    Property Etime() As String
        Get
            Return myEtime
        End Get
        Set(ByVal value As String)
            myEtime = value
        End Set
    End Property
    Property NodeKey() As String
        Get
            Return myNodeKey
        End Get
        Set(ByVal Value As String)
            myNodeKey = Value
        End Set
    End Property
    Property SIG() As String
        Get
            Return mySig
        End Get
        Set(ByVal value As String)
            mySig = value
        End Set
    End Property
    Property SortKey() As String
        Get
            Return mySortKey
        End Get
        Set(ByVal Value As String)
            mySortKey = Value
        End Set
    End Property
    Property Status() As String
        Get
            Return myStatus
        End Get
        Set(ByVal value As String)
            myStatus = value
        End Set
    End Property
    Property RNType() As RnTypes
        Get
            Return myRNType
        End Get
        Set(ByVal value As RnTypes)
            myRNType = value
        End Set
    End Property
    Property Medcinid() As Integer
        Get
            Return myMedcinid
        End Get
        Set(ByVal Value As Integer)
            myMedcinid = Value
        End Set
    End Property
    Property Prefix() As String
        Get
            Return myPrefix
        End Get
        Set(ByVal Value As String)
            myPrefix = Value
        End Set
    End Property
    Property Unit() As String
        Get
            Return myUnit
        End Get
        Set(ByVal value As String)
            myUnit = value
        End Set
    End Property
    Property Value() As String
        Get
            Return myValue
        End Get
        Set(ByVal vdata As String)
            myValue = vdata
        End Set
    End Property
    Property RNRxList() As ArrayList
        Get
            Return myRNRxList
        End Get
        Set(ByVal value As ArrayList)
            myRNRxList = value
        End Set
    End Property
End Class
